package modele

import java.lang.reflect.Type
import kotlin.random.Random

class TypeShape(val type: EnumTypeShape){

    private var currentIndex = 0
    var showShape:Array<IntArray> = Array(4){ IntArray(4 ) { 0 } }
    var couleur:Int = 0

    init {
        when(type){
            EnumTypeShape.IShape -> {
                couleur = 1 // Set the color of the shape
                for( i in 0..3){
                    showShape[0][i] = 1  // Create shape
                }
            }
            EnumTypeShape.SquareShape -> {
                couleur = 6
                showShape[0][0] = 1
                showShape[0][1] = 1
                showShape[1][0] = 1
                showShape[1][1] = 1
            }
            EnumTypeShape.TShape -> {
                couleur = 7
                showShape[0][1] = 1
                showShape[1][0] = 1
                showShape[1][1] = 1
                showShape[1][2] = 1
            }
            EnumTypeShape.LShape -> {
                couleur = 5
                showShape[0][2] = 1
                showShape[1][0] = 1
                showShape[1][1] = 1
                showShape[1][2] = 1
            }
            EnumTypeShape.JShape -> {
                couleur = 4
                showShape[0][0] = 1
                showShape[1][0] = 1
                showShape[1][1] = 1
                showShape[1][2] = 1
            }
            EnumTypeShape.SShape -> {
                couleur = 3
                showShape[0][1] = 1
                showShape[0][2] = 1
                showShape[1][0] = 1
                showShape[1][1] = 1
            }
            EnumTypeShape.ZShape -> {
                couleur = 2
                showShape[0][0] = 1
                showShape[0][1] = 1
                showShape[1][1] = 1
                showShape[1][2] = 1
            }
            else -> {
                println("Type inconnu !")
            }
        }
    }

    /*
    fun getPoints(): Array<Position>{
        val positions = ArrayList<Position>()
        val typeShape = getCurrentType()
        for (i in typeShape.indices){
            for (j in typeShape[i].indices){
                if (typeShape[i][j] != 0) {
                    positions.add(Position(j, i))
                }
            }
        }
        return positions.toTypedArray()
    }

    //to augmente of 1 the current index
    fun getNextType(): TypeShape {
        currentIndex++
        return this
    }


    //To get the next shape
    fun getNextShape(){
        val random: Int = Random.nextInt(1,7)
        when(random){
            1 -> TypeShape(EnumTypeShape.IShape, arrayOf(arrayOf(arrayOf())))
            2 -> TypeShape(EnumTypeShape.SquareShape, arrayOf(arrayOf(arrayOf())))
            3 -> TypeShape(EnumTypeShape.JShape, arrayOf(arrayOf(arrayOf())))
            4 -> TypeShape(EnumTypeShape.LShape, arrayOf(arrayOf(arrayOf())))
            5 -> TypeShape(EnumTypeShape.SShape, arrayOf(arrayOf(arrayOf())))
            6 -> TypeShape(EnumTypeShape.TShape, arrayOf(arrayOf(arrayOf())))
            7 -> TypeShape(EnumTypeShape.ZShape, arrayOf(arrayOf(arrayOf())))
            else -> throw Exception("Problème de random getNextShape()")
        }
    }

    // To get the table of position of the current shape type
    private fun getCurrentType(): Array<Array<Int>> {
        return showShape[currentIndex]
    }*/
}